const timeRangeButtons = document.querySelector(`#timeRangeButtons`);
const dataTypeButtons = document.querySelector(`#dataTypeButtons`);

const artistsDataAllTimeNames = document.querySelector(`#artistsDataAllTimeNames`);
const artistsDataSixMonthsNames = document.querySelector(`#artistsDataSixMonthsNames`);
const artistsDataFourWeeksNames = document.querySelector(`#artistsDataFourWeeksNames`);
const trackDataAllTimeNames = document.querySelector(`#trackDataAllTimeNames`);
const trackDataSixMonthsNames = document.querySelector(`#trackDataSixMonthsNames`);
const trackDataFourWeeksNames = document.querySelector(`#trackDataFourWeeksNames`);

timeRangeButtons.addEventListener(`click`, (event) =>
{
    const clickedButton = event.target;
    const activeTimeRangeButton = timeRangeButtons.querySelector(`.btn-primary`);
    activeTimeRangeButton.classList.remove(`btn-primary`);
    activeTimeRangeButton.classList.add(`btn-secondary`);
    clickedButton.classList.add(`btn-primary`);
    clickedButton.classList.remove(`btn-secondary`);

    const selectedDataTypeButton = dataTypeButtons.querySelector(`.btn-primary`);
    const selectedDataType = selectedDataTypeButton.id;
    const selectedTimeRange = clickedButton.id;

    handleHiding(selectedTimeRange, selectedDataType);
});

dataTypeButtons.addEventListener(`click`, (event) =>
{
    const clickedButton = event.target;
    const activeDataTypeButton = dataTypeButtons.querySelector(`.btn-primary`);
    activeDataTypeButton.classList.remove(`btn-primary`);
    activeDataTypeButton.classList.add(`btn-secondary`);
    clickedButton.classList.add(`btn-primary`);
    clickedButton.classList.remove(`btn-secondary`);

    const selectedTimeRangeButton = timeRangeButtons.querySelector(`.btn-primary`);
    const selectedTimeRange = selectedTimeRangeButton.id;
    const selectedDataType = clickedButton.id;

    handleHiding(selectedTimeRange, selectedDataType);
});

/**
 * @param {string} timeRange The time range
 * @param {string} dataType The data type
 */
function handleHiding(timeRange, dataType)
{
    if (timeRange === `fourWeeks`
        && dataType === `artists`)
    {
        artistsDataAllTimeNames.classList.add(`d-none`);
        artistsDataSixMonthsNames.classList.add(`d-none`);
        artistsDataFourWeeksNames.classList.remove(`d-none`);
        trackDataAllTimeNames.classList.add(`d-none`);
        trackDataSixMonthsNames.classList.add(`d-none`);
        trackDataFourWeeksNames.classList.add(`d-none`);
    }
    else if (timeRange === `sixMonths`
        && dataType === `artists`)
    {
        artistsDataAllTimeNames.classList.add(`d-none`);
        artistsDataSixMonthsNames.classList.remove(`d-none`);
        artistsDataFourWeeksNames.classList.add(`d-none`);
        trackDataAllTimeNames.classList.add(`d-none`);
        trackDataSixMonthsNames.classList.add(`d-none`);
        trackDataFourWeeksNames.classList.add(`d-none`);
    }
    else if (timeRange === `allTime`
        && dataType === `artists`)
    {
        artistsDataAllTimeNames.classList.remove(`d-none`);
        artistsDataSixMonthsNames.classList.add(`d-none`);
        artistsDataFourWeeksNames.classList.add(`d-none`);
        trackDataAllTimeNames.classList.add(`d-none`);
        trackDataSixMonthsNames.classList.add(`d-none`);
        trackDataFourWeeksNames.classList.add(`d-none`);
    }
    else if (timeRange === `fourWeeks`
        && dataType === `tracks`)
    {
        artistsDataAllTimeNames.classList.add(`d-none`);
        artistsDataSixMonthsNames.classList.add(`d-none`);
        artistsDataFourWeeksNames.classList.add(`d-none`);
        trackDataAllTimeNames.classList.add(`d-none`);
        trackDataSixMonthsNames.classList.add(`d-none`);
        trackDataFourWeeksNames.classList.remove(`d-none`);
    }
    else if (timeRange === `sixMonths`
        && dataType === `tracks`)
    {
        artistsDataAllTimeNames.classList.add(`d-none`);
        artistsDataSixMonthsNames.classList.add(`d-none`);
        artistsDataFourWeeksNames.classList.add(`d-none`);
        trackDataAllTimeNames.classList.add(`d-none`);
        trackDataSixMonthsNames.classList.remove(`d-none`);
        trackDataFourWeeksNames.classList.add(`d-none`);
    }
    else if (timeRange === `allTime`
        && dataType === `tracks`)
    {
        artistsDataAllTimeNames.classList.add(`d-none`);
        artistsDataSixMonthsNames.classList.add(`d-none`);
        artistsDataFourWeeksNames.classList.add(`d-none`);
        trackDataAllTimeNames.classList.remove(`d-none`);
        trackDataSixMonthsNames.classList.add(`d-none`);
        trackDataFourWeeksNames.classList.add(`d-none`);
    }
}

const screenshotModeButton = document.querySelector(`#screenshotModeButton`);
screenshotModeButton.addEventListener(`click`, () =>
{
    const buttons = document.querySelectorAll(`.btn`);
    for (const button of buttons)
        button.style = `visibility: hidden;`;
});
