/* eslint-disable import/no-extraneous-dependencies */
/* eslint-disable newline-per-chained-call */
import express from "express";
import { config } from "dotenv";
import fetch from "node-fetch";
import
{
    checkAuthenticated
} from "../functions.js";

const router = new express.Router();
config(); // Load environment variables from .env file

// file deepcode ignore NoRateLimitingForExpensiveWebOperation: Already rate limited in src/app.js
router.get(`/`, checkAuthenticated, async (request, response) =>
{
    if (request.user)
    {
        const code = request.user;
        let artistsDataAllTimeNames; let artistsDataSixMonthsNames; let artistsDataFourWeeksNames; let trackDataAllTimeNames;
        let trackDataSixMonthsNames; let trackDataFourWeeksNames; let artistsDataAllTimeLinks; let artistsDataSixMonthsLinks; let artistsDataFourWeeksLinks;
        let trackDataAllTimeLinks; let trackDataSixMonthsLinks; let trackDataFourWeeksLinks;
        if (process.env.DEV === `true`)
        {
            // Spotify API please save my wrath.
            artistsDataAllTimeNames = [
                `Artist Name`,
                `Artist Name`,
                `Artist Name`,
                `Artist Name`,
                `Artist Name`,
                `Artist Name`,
                `Artist Name`,
                `Artist Name`,
                `Artist Name`,
                `Artist Name`,
            ];
            trackDataFourWeeksNames = [
                `Song Name - Artist Name`,
                `Song Name - Artist Name`,
                `Song Name - Artist Name`,
                `Song Name - Artist Name`,
                `Song Name - Artist Name`,
                `Song Name - Artist Name`,
                `Song Name - Artist Name`,
                `Song Name - Artist Name`,
                `Song Name - Artist Name`,
                `Song Name - Artist Name`,
            ];
            artistsDataSixMonthsNames = artistsDataAllTimeNames;
            artistsDataFourWeeksNames = artistsDataAllTimeNames;
            trackDataSixMonthsNames = trackDataFourWeeksNames;
            trackDataAllTimeNames = trackDataFourWeeksNames;

            artistsDataAllTimeLinks = [
                `https://open.spotify.com/`,
                `https://open.spotify.com/`,
                `https://open.spotify.com/`,
                `https://open.spotify.com/`,
                `https://open.spotify.com/`,
                `https://open.spotify.com/`,
                `https://open.spotify.com/`,
                `https://open.spotify.com/`,
                `https://open.spotify.com/`,
                `https://open.spotify.com/`,
            ];
            trackDataFourWeeksLinks = artistsDataAllTimeLinks;
            artistsDataSixMonthsLinks = artistsDataAllTimeLinks;
            artistsDataFourWeeksLinks = artistsDataAllTimeLinks;
            trackDataSixMonthsLinks = artistsDataAllTimeLinks;
            trackDataAllTimeLinks = artistsDataAllTimeLinks;
        }
        else
        {
            try
            {
                const artistsDataAllTime = await fetch(`https://api.spotify.com/v1/me/top/artists?time_range=long_term&limit=10`, {
                    method: `GET`,
                    headers: {
                        Authorization: `Bearer ${ code }`,
                    },
                }).catch((error) =>
                {
                    console.log(error);
                    return response.redirect(`/error`);
                }).then((response) => response.json());

                if (artistsDataAllTime.error)
                    return response.redirect(`/error`);

                artistsDataAllTimeNames = artistsDataAllTime.items.map((item) => item.name);
                artistsDataAllTimeLinks = artistsDataAllTime.items.map((item) => item.external_urls.spotify);

                const artistsDataSixMonths = await fetch(`https://api.spotify.com/v1/me/top/artists?time_range=medium_term&limit=10`, {
                    method: `GET`,
                    headers: {
                        Authorization: `Bearer ${ code }`,
                    },
                }).catch((error) =>
                {
                    console.log(error);
                    return response.redirect(`/error`);
                }).then((response) => response.json());

                artistsDataSixMonthsNames = artistsDataSixMonths.items.map((item) => item.name);
                artistsDataSixMonthsLinks = artistsDataSixMonths.items.map((item) => item.external_urls.spotify);

                const artistsDataFourWeeks = await fetch(`https://api.spotify.com/v1/me/top/artists?time_range=short_term&limit=10`, {
                    method: `GET`,
                    headers: {
                        Authorization: `Bearer ${ code }`,
                    },
                }).catch((error) =>
                {
                    console.log(error);
                    return response.redirect(`/error`);
                }).then((response) => response.json());

                artistsDataFourWeeksNames = artistsDataFourWeeks.items.map((item) => item.name);
                artistsDataFourWeeksLinks = artistsDataFourWeeks.items.map((item) => item.external_urls.spotify);

                const trackDataAllTime = await fetch(`https://api.spotify.com/v1/me/top/tracks?time_range=long_term&limit=10`, {
                    method: `GET`,
                    headers: {
                        Authorization: `Bearer ${ code }`,
                    },
                }).catch((error) =>
                {
                    console.log(error);
                    return response.redirect(`/error`);
                }).then((response) => response.json());

                trackDataAllTimeNames = trackDataAllTime.items.map((item) =>
                {
                    const artists = item.artists.map((artist) => artist.name);
                    return `${ item.name } - ${ artists.join(`, `) }`;
                });

                trackDataAllTimeLinks = trackDataAllTime.items.map((item) => item.external_urls.spotify);

                const trackDataSixMonths = await fetch(`https://api.spotify.com/v1/me/top/tracks?time_range=medium_term&limit=10`, {
                    method: `GET`,
                    headers: {
                        Authorization: `Bearer ${ code }`,
                    },
                }).catch((error) =>
                {
                    console.log(error);
                    return response.redirect(`/error`);
                }).then((response) => response.json());

                trackDataSixMonthsNames = trackDataSixMonths.items.map((item) =>
                {
                    const artists = item.artists.map((artist) => artist.name);
                    return `${ item.name } - ${ artists.join(`, `) }`;
                });

                trackDataSixMonthsLinks = trackDataSixMonths.items.map((item) => item.external_urls.spotify);

                const trackDataFourWeeks = await fetch(`https://api.spotify.com/v1/me/top/tracks?time_range=short_term&limit=10`, {
                    method: `GET`,
                    headers: {
                        Authorization: `Bearer ${ code }`,
                    },
                }).catch((error) =>
                {
                    console.log(error);
                    return response.redirect(`/error`);
                }).then((response) => response.json());

                trackDataFourWeeksNames = trackDataFourWeeks.items.map((item) =>
                {
                    const artists = item.artists.map((artist) => artist.name);
                    return `${ item.name } - ${ artists.join(`, `) }`;
                });

                trackDataFourWeeksLinks = trackDataFourWeeks.items.map((item) => item.external_urls.spotify);
            }
            catch
            {
                return response.redirect(`/error`);
            }
        }

        response.render(`profile.ejs`, {
            artistsDataAllTimeNames,
            artistsDataSixMonthsNames,
            artistsDataFourWeeksNames,
            trackDataAllTimeNames,
            trackDataSixMonthsNames,
            trackDataFourWeeksNames,
            artistsDataAllTimeLinks,
            artistsDataSixMonthsLinks,
            artistsDataFourWeeksLinks,
            trackDataAllTimeLinks,
            trackDataSixMonthsLinks,
            trackDataFourWeeksLinks,
        });
    }
    else
        return response.redirect(`/login/spotify`);
});

export default router;
